PEG.grammarParser = (function(){
  /* Generated by PEG.js (http://pegjs.majda.cz/). */
  
  var result = {
    _startRule: "grammar",
    
    _quoteString: function(s) {
      /*
       * ECMA-262, 5th ed., 7.8.4: All characters may appear literally in a string
       * literal except for the closing quote character, backslash, carriage
       * return, line separator, paragraph separator, and line feed. Any character
       * may appear in the form of an escape sequence.
       */
      return '"' + s
        .replace(/\\/g, '\\\\')        // backslash
        .replace(/"/g, '\\"')          // closing quote character
        .replace(/\r/g, '\\r')         // carriage return
        .replace(/\u2028/g, '\\u2028') // line separator
        .replace(/\u2029/g, '\\u2029') // paragraph separator
        .replace(/\n/g, '\\n')         // line feed
        + '"';
    },
    
    _arrayContains: function(array, value) {
      /*
       * Stupid IE does not have Array.prototype.indexOf, otherwise this function
       * would be a one-liner.
       */
      var length = array.length;
      for (var i = 0; i < length; i++) {
        if (array[i] === value) {
          return true;
        }
      }
      return false;
    },
    
    _matchFailed: function(failure) {
      if (this._pos > this._rightmostMatchFailuresPos) {
        this._rightmostMatchFailuresPos = this._pos;
        this._rightmostMatchFailuresExpected = [];
      }
      
      if (!this._arrayContains(this._rightmostMatchFailuresExpected, failure)) {
        this._rightmostMatchFailuresExpected.push(failure);
      }
    },
    
    _parse_grammar: function(context) {
      var cacheKey = "grammar" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos0 = this._pos;
      var result2 = this._parse___(context);
      if (result2 !== null) {
        var result4 = this._parse_rule(context);
        if (result4 !== null) {
          var result3 = [];
          while (result4 !== null) {
            result3.push(result4);
            var result4 = this._parse_rule(context);
          }
        } else {
          var result3 = null;
        }
        if (result3 !== null) {
          var result1 = [result2, result3];
        } else {
          var result1 = null;
          this._pos = savedPos0;
        }
      } else {
        var result1 = null;
        this._pos = savedPos0;
      }
      var result0 = result1 !== null
        ? (function($1, $2) { 
          var result = {};
          PEG.ArrayUtils.each($2, function(rule) { result[rule.name] = rule; });
          return result;
         }).apply(null, result1)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result0
      };
      return result0;
    },
    
    _parse_rule: function(context) {
      var cacheKey = "rule" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos1 = this._pos;
      var result7 = this._parse_identifier(context);
      if (result7 !== null) {
        var result12 = this._parse_literal(context);
        if (result12 !== null) {
          var result8 = result12;
        } else {
          if (this._input.substr(this._pos, 0) === "") {
            var result11 = "";
            this._pos += 0;
          } else {
            var result11 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString(""));
            }
          }
          if (result11 !== null) {
            var result8 = result11;
          } else {
            var result8 = null;;
          };
        }
        if (result8 !== null) {
          var result9 = this._parse_colon(context);
          if (result9 !== null) {
            var result10 = this._parse_expression(context);
            if (result10 !== null) {
              var result6 = [result7, result8, result9, result10];
            } else {
              var result6 = null;
              this._pos = savedPos1;
            }
          } else {
            var result6 = null;
            this._pos = savedPos1;
          }
        } else {
          var result6 = null;
          this._pos = savedPos1;
        }
      } else {
        var result6 = null;
        this._pos = savedPos1;
      }
      var result5 = result6 !== null
        ? (function($1, $2, $3, $4) { 
          return {
            type:        "rule",
            name:        $1,
            displayName: $2 !== "" ? $2 : null,
            expression:  $4
          };
         }).apply(null, result6)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result5
      };
      return result5;
    },
    
    _parse_expression: function(context) {
      var cacheKey = "expression" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result13 = this._parse_choice(context);
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result13
      };
      return result13;
    },
    
    _parse_choice: function(context) {
      var cacheKey = "choice" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos2 = this._pos;
      var result16 = this._parse_sequence(context);
      if (result16 !== null) {
        var result17 = [];
        var savedPos3 = this._pos;
        var result19 = this._parse_slash(context);
        if (result19 !== null) {
          var result20 = this._parse_sequence(context);
          if (result20 !== null) {
            var result18 = [result19, result20];
          } else {
            var result18 = null;
            this._pos = savedPos3;
          }
        } else {
          var result18 = null;
          this._pos = savedPos3;
        }
        while (result18 !== null) {
          result17.push(result18);
          var savedPos3 = this._pos;
          var result19 = this._parse_slash(context);
          if (result19 !== null) {
            var result20 = this._parse_sequence(context);
            if (result20 !== null) {
              var result18 = [result19, result20];
            } else {
              var result18 = null;
              this._pos = savedPos3;
            }
          } else {
            var result18 = null;
            this._pos = savedPos3;
          }
        }
        if (result17 !== null) {
          var result15 = [result16, result17];
        } else {
          var result15 = null;
          this._pos = savedPos2;
        }
      } else {
        var result15 = null;
        this._pos = savedPos2;
      }
      var result14 = result15 !== null
        ? (function($1, $2) { 
          if ($2.length > 0) {
            var alternatives = [$1].concat(PEG.ArrayUtils.map(
                $2,
                function(element) { return element[1]; }
            ));
            return {
              type:         "choice",
              alternatives: alternatives
            }
          } else {
            return $1;
          }
         }).apply(null, result15)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result14
      };
      return result14;
    },
    
    _parse_sequence: function(context) {
      var cacheKey = "sequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos4 = this._pos;
      var result27 = [];
      var result29 = this._parse_prefixed(context);
      while (result29 !== null) {
        result27.push(result29);
        var result29 = this._parse_prefixed(context);
      }
      if (result27 !== null) {
        var result28 = this._parse_action(context);
        if (result28 !== null) {
          var result26 = [result27, result28];
        } else {
          var result26 = null;
          this._pos = savedPos4;
        }
      } else {
        var result26 = null;
        this._pos = savedPos4;
      }
      var result25 = result26 !== null
        ? (function($1, $2) { 
              var expression = $1.length != 1
                ? {
                    type:     "sequence",
                    elements: $1
                  }
                : $1[0];
              return {
                type:       "action",
                expression: expression,
                action:     $2
              };
             }).apply(null, result26)
        : null;
      if (result25 !== null) {
        var result21 = result25;
      } else {
        var result23 = [];
        var result24 = this._parse_prefixed(context);
        while (result24 !== null) {
          result23.push(result24);
          var result24 = this._parse_prefixed(context);
        }
        var result22 = result23 !== null
          ? (function($1) { 
                return $1.length != 1
                  ? {
                      type:     "sequence",
                      elements: $1
                    }
                  : $1[0];
               })(result23)
          : null;
        if (result22 !== null) {
          var result21 = result22;
        } else {
          var result21 = null;;
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result21
      };
      return result21;
    },
    
    _parse_prefixed: function(context) {
      var cacheKey = "prefixed" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos6 = this._pos;
      var result38 = this._parse_and(context);
      if (result38 !== null) {
        var result39 = this._parse_suffixed(context);
        if (result39 !== null) {
          var result37 = [result38, result39];
        } else {
          var result37 = null;
          this._pos = savedPos6;
        }
      } else {
        var result37 = null;
        this._pos = savedPos6;
      }
      var result36 = result37 !== null
        ? (function($1, $2) {  return { type: "and_predicate", expression: $2 };  }).apply(null, result37)
        : null;
      if (result36 !== null) {
        var result30 = result36;
      } else {
        var savedPos5 = this._pos;
        var result34 = this._parse_not(context);
        if (result34 !== null) {
          var result35 = this._parse_suffixed(context);
          if (result35 !== null) {
            var result33 = [result34, result35];
          } else {
            var result33 = null;
            this._pos = savedPos5;
          }
        } else {
          var result33 = null;
          this._pos = savedPos5;
        }
        var result32 = result33 !== null
          ? (function($1, $2) {  return { type: "not_predicate", expression: $2 };  }).apply(null, result33)
          : null;
        if (result32 !== null) {
          var result30 = result32;
        } else {
          var result31 = this._parse_suffixed(context);
          if (result31 !== null) {
            var result30 = result31;
          } else {
            var result30 = null;;
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result30
      };
      return result30;
    },
    
    _parse_suffixed: function(context) {
      var cacheKey = "suffixed" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos9 = this._pos;
      var result52 = this._parse_primary(context);
      if (result52 !== null) {
        var result53 = this._parse_question(context);
        if (result53 !== null) {
          var result51 = [result52, result53];
        } else {
          var result51 = null;
          this._pos = savedPos9;
        }
      } else {
        var result51 = null;
        this._pos = savedPos9;
      }
      var result50 = result51 !== null
        ? (function($1, $2) {  return { type: "optional",     expression: $1};  }).apply(null, result51)
        : null;
      if (result50 !== null) {
        var result40 = result50;
      } else {
        var savedPos8 = this._pos;
        var result48 = this._parse_primary(context);
        if (result48 !== null) {
          var result49 = this._parse_star(context);
          if (result49 !== null) {
            var result47 = [result48, result49];
          } else {
            var result47 = null;
            this._pos = savedPos8;
          }
        } else {
          var result47 = null;
          this._pos = savedPos8;
        }
        var result46 = result47 !== null
          ? (function($1, $2) {  return { type: "zero_or_more", expression: $1};  }).apply(null, result47)
          : null;
        if (result46 !== null) {
          var result40 = result46;
        } else {
          var savedPos7 = this._pos;
          var result44 = this._parse_primary(context);
          if (result44 !== null) {
            var result45 = this._parse_plus(context);
            if (result45 !== null) {
              var result43 = [result44, result45];
            } else {
              var result43 = null;
              this._pos = savedPos7;
            }
          } else {
            var result43 = null;
            this._pos = savedPos7;
          }
          var result42 = result43 !== null
            ? (function($1, $2) {  return { type: "one_or_more",  expression: $1};  }).apply(null, result43)
            : null;
          if (result42 !== null) {
            var result40 = result42;
          } else {
            var result41 = this._parse_primary(context);
            if (result41 !== null) {
              var result40 = result41;
            } else {
              var result40 = null;;
            };
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result40
      };
      return result40;
    },
    
    _parse_primary: function(context) {
      var cacheKey = "primary" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos11 = this._pos;
      var result67 = this._parse_identifier(context);
      if (result67 !== null) {
        var savedPos12 = this._pos;
        var savedReportMatchFailuresVar0 = context.reportMatchFailures;
        context.reportMatchFailures = false;
        var savedPos13 = this._pos;
        var result73 = this._parse_literal(context);
        if (result73 !== null) {
          var result70 = result73;
        } else {
          if (this._input.substr(this._pos, 0) === "") {
            var result72 = "";
            this._pos += 0;
          } else {
            var result72 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString(""));
            }
          }
          if (result72 !== null) {
            var result70 = result72;
          } else {
            var result70 = null;;
          };
        }
        if (result70 !== null) {
          var result71 = this._parse_colon(context);
          if (result71 !== null) {
            var result69 = [result70, result71];
          } else {
            var result69 = null;
            this._pos = savedPos13;
          }
        } else {
          var result69 = null;
          this._pos = savedPos13;
        }
        context.reportMatchFailures = savedReportMatchFailuresVar0;
        if (result69 === null) {
          var result68 = '';
        } else {
          var result68 = null;
          this._pos = savedPos12;
        }
        if (result68 !== null) {
          var result66 = [result67, result68];
        } else {
          var result66 = null;
          this._pos = savedPos11;
        }
      } else {
        var result66 = null;
        this._pos = savedPos11;
      }
      var result65 = result66 !== null
        ? (function($1, $2) {  return { type: "rule_ref", name:  $1 };  }).apply(null, result66)
        : null;
      if (result65 !== null) {
        var result54 = result65;
      } else {
        var result64 = this._parse_literal(context);
        var result63 = result64 !== null
          ? (function($1) {  return { type: "literal",  value: $1 };  })(result64)
          : null;
        if (result63 !== null) {
          var result54 = result63;
        } else {
          var result62 = this._parse_dot(context);
          var result61 = result62 !== null
            ? (function($1) {  return { type: "any"                 };  })(result62)
            : null;
          if (result61 !== null) {
            var result54 = result61;
          } else {
            var result60 = this._parse_class(context);
            if (result60 !== null) {
              var result54 = result60;
            } else {
              var savedPos10 = this._pos;
              var result57 = this._parse_lparen(context);
              if (result57 !== null) {
                var result58 = this._parse_expression(context);
                if (result58 !== null) {
                  var result59 = this._parse_rparen(context);
                  if (result59 !== null) {
                    var result56 = [result57, result58, result59];
                  } else {
                    var result56 = null;
                    this._pos = savedPos10;
                  }
                } else {
                  var result56 = null;
                  this._pos = savedPos10;
                }
              } else {
                var result56 = null;
                this._pos = savedPos10;
              }
              var result55 = result56 !== null
                ? (function($1, $2, $3) {  return $2;  }).apply(null, result56)
                : null;
              if (result55 !== null) {
                var result54 = result55;
              } else {
                var result54 = null;;
              };
            };
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result54
      };
      return result54;
    },
    
    _parse_action: function(context) {
      var cacheKey = "action" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      var savedPos14 = this._pos;
      var result76 = this._parse_braced(context);
      if (result76 !== null) {
        var result77 = this._parse___(context);
        if (result77 !== null) {
          var result75 = [result76, result77];
        } else {
          var result75 = null;
          this._pos = savedPos14;
        }
      } else {
        var result75 = null;
        this._pos = savedPos14;
      }
      var result74 = result75 !== null
        ? (function($1, $2) {  return $1.substr(1, $1.length - 2);  }).apply(null, result75)
        : null;
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result74 === null) {
        this._matchFailed("action");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result74
      };
      return result74;
    },
    
    _parse_braced: function(context) {
      var cacheKey = "braced" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos15 = this._pos;
      if (this._input.substr(this._pos, 1) === "{") {
        var result80 = "{";
        this._pos += 1;
      } else {
        var result80 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("{"));
        }
      }
      if (result80 !== null) {
        var result81 = [];
        var result85 = this._parse_braced(context);
        if (result85 !== null) {
          var result83 = result85;
        } else {
          var result84 = this._parse_nonBraceCharacter(context);
          if (result84 !== null) {
            var result83 = result84;
          } else {
            var result83 = null;;
          };
        }
        while (result83 !== null) {
          result81.push(result83);
          var result85 = this._parse_braced(context);
          if (result85 !== null) {
            var result83 = result85;
          } else {
            var result84 = this._parse_nonBraceCharacter(context);
            if (result84 !== null) {
              var result83 = result84;
            } else {
              var result83 = null;;
            };
          }
        }
        if (result81 !== null) {
          if (this._input.substr(this._pos, 1) === "}") {
            var result82 = "}";
            this._pos += 1;
          } else {
            var result82 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("}"));
            }
          }
          if (result82 !== null) {
            var result79 = [result80, result81, result82];
          } else {
            var result79 = null;
            this._pos = savedPos15;
          }
        } else {
          var result79 = null;
          this._pos = savedPos15;
        }
      } else {
        var result79 = null;
        this._pos = savedPos15;
      }
      var result78 = result79 !== null
        ? (function($1, $2, $3) {  return $1 + $2.join("") + $3;  }).apply(null, result79)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result78
      };
      return result78;
    },
    
    _parse_nonBraceCharacters: function(context) {
      var cacheKey = "nonBraceCharacters" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result88 = this._parse_nonBraceCharacter(context);
      if (result88 !== null) {
        var result87 = [];
        while (result88 !== null) {
          result87.push(result88);
          var result88 = this._parse_nonBraceCharacter(context);
        }
      } else {
        var result87 = null;
      }
      var result86 = result87 !== null
        ? (function($1) {  return $1.join("");  })(result87)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result86
      };
      return result86;
    },
    
    _parse_nonBraceCharacter: function(context) {
      var cacheKey = "nonBraceCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[^{}]/) !== null) {
        var result90 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result90 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[^{}]");
        }
      }
      var result89 = result90 !== null
        ? (function($1) {  return $1;  })(result90)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result89
      };
      return result89;
    },
    
    _parse_colon: function(context) {
      var cacheKey = "colon" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos16 = this._pos;
      if (this._input.substr(this._pos, 1) === ":") {
        var result93 = ":";
        this._pos += 1;
      } else {
        var result93 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString(":"));
        }
      }
      if (result93 !== null) {
        var result94 = this._parse___(context);
        if (result94 !== null) {
          var result92 = [result93, result94];
        } else {
          var result92 = null;
          this._pos = savedPos16;
        }
      } else {
        var result92 = null;
        this._pos = savedPos16;
      }
      var result91 = result92 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result92)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result91
      };
      return result91;
    },
    
    _parse_slash: function(context) {
      var cacheKey = "slash" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos17 = this._pos;
      if (this._input.substr(this._pos, 1) === "/") {
        var result97 = "/";
        this._pos += 1;
      } else {
        var result97 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("/"));
        }
      }
      if (result97 !== null) {
        var result98 = this._parse___(context);
        if (result98 !== null) {
          var result96 = [result97, result98];
        } else {
          var result96 = null;
          this._pos = savedPos17;
        }
      } else {
        var result96 = null;
        this._pos = savedPos17;
      }
      var result95 = result96 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result96)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result95
      };
      return result95;
    },
    
    _parse_and: function(context) {
      var cacheKey = "and" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos18 = this._pos;
      if (this._input.substr(this._pos, 1) === "&") {
        var result101 = "&";
        this._pos += 1;
      } else {
        var result101 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("&"));
        }
      }
      if (result101 !== null) {
        var result102 = this._parse___(context);
        if (result102 !== null) {
          var result100 = [result101, result102];
        } else {
          var result100 = null;
          this._pos = savedPos18;
        }
      } else {
        var result100 = null;
        this._pos = savedPos18;
      }
      var result99 = result100 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result100)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result99
      };
      return result99;
    },
    
    _parse_not: function(context) {
      var cacheKey = "not" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos19 = this._pos;
      if (this._input.substr(this._pos, 1) === "!") {
        var result105 = "!";
        this._pos += 1;
      } else {
        var result105 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("!"));
        }
      }
      if (result105 !== null) {
        var result106 = this._parse___(context);
        if (result106 !== null) {
          var result104 = [result105, result106];
        } else {
          var result104 = null;
          this._pos = savedPos19;
        }
      } else {
        var result104 = null;
        this._pos = savedPos19;
      }
      var result103 = result104 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result104)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result103
      };
      return result103;
    },
    
    _parse_question: function(context) {
      var cacheKey = "question" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos20 = this._pos;
      if (this._input.substr(this._pos, 1) === "?") {
        var result109 = "?";
        this._pos += 1;
      } else {
        var result109 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("?"));
        }
      }
      if (result109 !== null) {
        var result110 = this._parse___(context);
        if (result110 !== null) {
          var result108 = [result109, result110];
        } else {
          var result108 = null;
          this._pos = savedPos20;
        }
      } else {
        var result108 = null;
        this._pos = savedPos20;
      }
      var result107 = result108 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result108)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result107
      };
      return result107;
    },
    
    _parse_star: function(context) {
      var cacheKey = "star" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos21 = this._pos;
      if (this._input.substr(this._pos, 1) === "*") {
        var result113 = "*";
        this._pos += 1;
      } else {
        var result113 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("*"));
        }
      }
      if (result113 !== null) {
        var result114 = this._parse___(context);
        if (result114 !== null) {
          var result112 = [result113, result114];
        } else {
          var result112 = null;
          this._pos = savedPos21;
        }
      } else {
        var result112 = null;
        this._pos = savedPos21;
      }
      var result111 = result112 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result112)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result111
      };
      return result111;
    },
    
    _parse_plus: function(context) {
      var cacheKey = "plus" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos22 = this._pos;
      if (this._input.substr(this._pos, 1) === "+") {
        var result117 = "+";
        this._pos += 1;
      } else {
        var result117 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("+"));
        }
      }
      if (result117 !== null) {
        var result118 = this._parse___(context);
        if (result118 !== null) {
          var result116 = [result117, result118];
        } else {
          var result116 = null;
          this._pos = savedPos22;
        }
      } else {
        var result116 = null;
        this._pos = savedPos22;
      }
      var result115 = result116 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result116)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result115
      };
      return result115;
    },
    
    _parse_lparen: function(context) {
      var cacheKey = "lparen" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos23 = this._pos;
      if (this._input.substr(this._pos, 1) === "(") {
        var result121 = "(";
        this._pos += 1;
      } else {
        var result121 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("("));
        }
      }
      if (result121 !== null) {
        var result122 = this._parse___(context);
        if (result122 !== null) {
          var result120 = [result121, result122];
        } else {
          var result120 = null;
          this._pos = savedPos23;
        }
      } else {
        var result120 = null;
        this._pos = savedPos23;
      }
      var result119 = result120 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result120)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result119
      };
      return result119;
    },
    
    _parse_rparen: function(context) {
      var cacheKey = "rparen" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos24 = this._pos;
      if (this._input.substr(this._pos, 1) === ")") {
        var result125 = ")";
        this._pos += 1;
      } else {
        var result125 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString(")"));
        }
      }
      if (result125 !== null) {
        var result126 = this._parse___(context);
        if (result126 !== null) {
          var result124 = [result125, result126];
        } else {
          var result124 = null;
          this._pos = savedPos24;
        }
      } else {
        var result124 = null;
        this._pos = savedPos24;
      }
      var result123 = result124 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result124)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result123
      };
      return result123;
    },
    
    _parse_dot: function(context) {
      var cacheKey = "dot" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos25 = this._pos;
      if (this._input.substr(this._pos, 1) === ".") {
        var result129 = ".";
        this._pos += 1;
      } else {
        var result129 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("."));
        }
      }
      if (result129 !== null) {
        var result130 = this._parse___(context);
        if (result130 !== null) {
          var result128 = [result129, result130];
        } else {
          var result128 = null;
          this._pos = savedPos25;
        }
      } else {
        var result128 = null;
        this._pos = savedPos25;
      }
      var result127 = result128 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result128)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result127
      };
      return result127;
    },
    
    _parse_identifier: function(context) {
      var cacheKey = "identifier" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      var savedPos26 = this._pos;
      var result143 = this._parse_letter(context);
      if (result143 !== null) {
        var result133 = result143;
      } else {
        if (this._input.substr(this._pos, 1) === "_") {
          var result142 = "_";
          this._pos += 1;
        } else {
          var result142 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("_"));
          }
        }
        if (result142 !== null) {
          var result133 = result142;
        } else {
          if (this._input.substr(this._pos, 1) === "$") {
            var result141 = "$";
            this._pos += 1;
          } else {
            var result141 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("$"));
            }
          }
          if (result141 !== null) {
            var result133 = result141;
          } else {
            var result133 = null;;
          };
        };
      }
      if (result133 !== null) {
        var result134 = [];
        var result140 = this._parse_letter(context);
        if (result140 !== null) {
          var result136 = result140;
        } else {
          var result139 = this._parse_digit(context);
          if (result139 !== null) {
            var result136 = result139;
          } else {
            if (this._input.substr(this._pos, 1) === "_") {
              var result138 = "_";
              this._pos += 1;
            } else {
              var result138 = null;
              if (context.reportMatchFailures) {
                this._matchFailed(this._quoteString("_"));
              }
            }
            if (result138 !== null) {
              var result136 = result138;
            } else {
              if (this._input.substr(this._pos, 1) === "$") {
                var result137 = "$";
                this._pos += 1;
              } else {
                var result137 = null;
                if (context.reportMatchFailures) {
                  this._matchFailed(this._quoteString("$"));
                }
              }
              if (result137 !== null) {
                var result136 = result137;
              } else {
                var result136 = null;;
              };
            };
          };
        }
        while (result136 !== null) {
          result134.push(result136);
          var result140 = this._parse_letter(context);
          if (result140 !== null) {
            var result136 = result140;
          } else {
            var result139 = this._parse_digit(context);
            if (result139 !== null) {
              var result136 = result139;
            } else {
              if (this._input.substr(this._pos, 1) === "_") {
                var result138 = "_";
                this._pos += 1;
              } else {
                var result138 = null;
                if (context.reportMatchFailures) {
                  this._matchFailed(this._quoteString("_"));
                }
              }
              if (result138 !== null) {
                var result136 = result138;
              } else {
                if (this._input.substr(this._pos, 1) === "$") {
                  var result137 = "$";
                  this._pos += 1;
                } else {
                  var result137 = null;
                  if (context.reportMatchFailures) {
                    this._matchFailed(this._quoteString("$"));
                  }
                }
                if (result137 !== null) {
                  var result136 = result137;
                } else {
                  var result136 = null;;
                };
              };
            };
          }
        }
        if (result134 !== null) {
          var result135 = this._parse___(context);
          if (result135 !== null) {
            var result132 = [result133, result134, result135];
          } else {
            var result132 = null;
            this._pos = savedPos26;
          }
        } else {
          var result132 = null;
          this._pos = savedPos26;
        }
      } else {
        var result132 = null;
        this._pos = savedPos26;
      }
      var result131 = result132 !== null
        ? (function($1, $2, $3) { 
          return $1 + $2.join("");
         }).apply(null, result132)
        : null;
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result131 === null) {
        this._matchFailed("identifier");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result131
      };
      return result131;
    },
    
    _parse_literal: function(context) {
      var cacheKey = "literal" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      var savedPos27 = this._pos;
      var result149 = this._parse_doubleQuotedLiteral(context);
      if (result149 !== null) {
        var result146 = result149;
      } else {
        var result148 = this._parse_singleQuotedLiteral(context);
        if (result148 !== null) {
          var result146 = result148;
        } else {
          var result146 = null;;
        };
      }
      if (result146 !== null) {
        var result147 = this._parse___(context);
        if (result147 !== null) {
          var result145 = [result146, result147];
        } else {
          var result145 = null;
          this._pos = savedPos27;
        }
      } else {
        var result145 = null;
        this._pos = savedPos27;
      }
      var result144 = result145 !== null
        ? (function($1, $2) {  return $1;  }).apply(null, result145)
        : null;
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result144 === null) {
        this._matchFailed("literal");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result144
      };
      return result144;
    },
    
    _parse_doubleQuotedLiteral: function(context) {
      var cacheKey = "doubleQuotedLiteral" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos28 = this._pos;
      if (this._input.substr(this._pos, 1) === "\"") {
        var result152 = "\"";
        this._pos += 1;
      } else {
        var result152 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\""));
        }
      }
      if (result152 !== null) {
        var result153 = [];
        var result155 = this._parse_doubleQuotedCharacter(context);
        while (result155 !== null) {
          result153.push(result155);
          var result155 = this._parse_doubleQuotedCharacter(context);
        }
        if (result153 !== null) {
          if (this._input.substr(this._pos, 1) === "\"") {
            var result154 = "\"";
            this._pos += 1;
          } else {
            var result154 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("\""));
            }
          }
          if (result154 !== null) {
            var result151 = [result152, result153, result154];
          } else {
            var result151 = null;
            this._pos = savedPos28;
          }
        } else {
          var result151 = null;
          this._pos = savedPos28;
        }
      } else {
        var result151 = null;
        this._pos = savedPos28;
      }
      var result150 = result151 !== null
        ? (function($1, $2, $3) {  return $2.join("");  }).apply(null, result151)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result150
      };
      return result150;
    },
    
    _parse_doubleQuotedCharacter: function(context) {
      var cacheKey = "doubleQuotedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result162 = this._parse_simpleDoubleQuotedCharacter(context);
      if (result162 !== null) {
        var result156 = result162;
      } else {
        var result161 = this._parse_simpleEscapeSequence(context);
        if (result161 !== null) {
          var result156 = result161;
        } else {
          var result160 = this._parse_zeroEscapeSequence(context);
          if (result160 !== null) {
            var result156 = result160;
          } else {
            var result159 = this._parse_hexEscapeSequence(context);
            if (result159 !== null) {
              var result156 = result159;
            } else {
              var result158 = this._parse_unicodeEscapeSequence(context);
              if (result158 !== null) {
                var result156 = result158;
              } else {
                var result157 = this._parse_eolEscapeSequence(context);
                if (result157 !== null) {
                  var result156 = result157;
                } else {
                  var result156 = null;;
                };
              };
            };
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result156
      };
      return result156;
    },
    
    _parse_simpleDoubleQuotedCharacter: function(context) {
      var cacheKey = "simpleDoubleQuotedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos29 = this._pos;
      var savedPos30 = this._pos;
      var savedReportMatchFailuresVar1 = context.reportMatchFailures;
      context.reportMatchFailures = false;
      if (this._input.substr(this._pos, 1) === "\"") {
        var result170 = "\"";
        this._pos += 1;
      } else {
        var result170 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\""));
        }
      }
      if (result170 !== null) {
        var result167 = result170;
      } else {
        if (this._input.substr(this._pos, 1) === "\\") {
          var result169 = "\\";
          this._pos += 1;
        } else {
          var result169 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("\\"));
          }
        }
        if (result169 !== null) {
          var result167 = result169;
        } else {
          var result168 = this._parse_eolChar(context);
          if (result168 !== null) {
            var result167 = result168;
          } else {
            var result167 = null;;
          };
        };
      }
      context.reportMatchFailures = savedReportMatchFailuresVar1;
      if (result167 === null) {
        var result165 = '';
      } else {
        var result165 = null;
        this._pos = savedPos30;
      }
      if (result165 !== null) {
        if (this._input.length > this._pos) {
          var result166 = this._input.charAt(this._pos);
          this._pos++;
        } else {
          var result166 = null;
          if (context.reportMatchFailures) {
            this._matchFailed('any character');
          }
        }
        if (result166 !== null) {
          var result164 = [result165, result166];
        } else {
          var result164 = null;
          this._pos = savedPos29;
        }
      } else {
        var result164 = null;
        this._pos = savedPos29;
      }
      var result163 = result164 !== null
        ? (function($1, $2) {  return $2;  }).apply(null, result164)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result163
      };
      return result163;
    },
    
    _parse_singleQuotedLiteral: function(context) {
      var cacheKey = "singleQuotedLiteral" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos31 = this._pos;
      if (this._input.substr(this._pos, 1) === "'") {
        var result173 = "'";
        this._pos += 1;
      } else {
        var result173 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("'"));
        }
      }
      if (result173 !== null) {
        var result174 = [];
        var result176 = this._parse_singleQuotedCharacter(context);
        while (result176 !== null) {
          result174.push(result176);
          var result176 = this._parse_singleQuotedCharacter(context);
        }
        if (result174 !== null) {
          if (this._input.substr(this._pos, 1) === "'") {
            var result175 = "'";
            this._pos += 1;
          } else {
            var result175 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("'"));
            }
          }
          if (result175 !== null) {
            var result172 = [result173, result174, result175];
          } else {
            var result172 = null;
            this._pos = savedPos31;
          }
        } else {
          var result172 = null;
          this._pos = savedPos31;
        }
      } else {
        var result172 = null;
        this._pos = savedPos31;
      }
      var result171 = result172 !== null
        ? (function($1, $2, $3) {  return $2.join("");  }).apply(null, result172)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result171
      };
      return result171;
    },
    
    _parse_singleQuotedCharacter: function(context) {
      var cacheKey = "singleQuotedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result183 = this._parse_simpleSingleQuotedCharacter(context);
      if (result183 !== null) {
        var result177 = result183;
      } else {
        var result182 = this._parse_simpleEscapeSequence(context);
        if (result182 !== null) {
          var result177 = result182;
        } else {
          var result181 = this._parse_zeroEscapeSequence(context);
          if (result181 !== null) {
            var result177 = result181;
          } else {
            var result180 = this._parse_hexEscapeSequence(context);
            if (result180 !== null) {
              var result177 = result180;
            } else {
              var result179 = this._parse_unicodeEscapeSequence(context);
              if (result179 !== null) {
                var result177 = result179;
              } else {
                var result178 = this._parse_eolEscapeSequence(context);
                if (result178 !== null) {
                  var result177 = result178;
                } else {
                  var result177 = null;;
                };
              };
            };
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result177
      };
      return result177;
    },
    
    _parse_simpleSingleQuotedCharacter: function(context) {
      var cacheKey = "simpleSingleQuotedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos32 = this._pos;
      var savedPos33 = this._pos;
      var savedReportMatchFailuresVar2 = context.reportMatchFailures;
      context.reportMatchFailures = false;
      if (this._input.substr(this._pos, 1) === "'") {
        var result191 = "'";
        this._pos += 1;
      } else {
        var result191 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("'"));
        }
      }
      if (result191 !== null) {
        var result188 = result191;
      } else {
        if (this._input.substr(this._pos, 1) === "\\") {
          var result190 = "\\";
          this._pos += 1;
        } else {
          var result190 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("\\"));
          }
        }
        if (result190 !== null) {
          var result188 = result190;
        } else {
          var result189 = this._parse_eolChar(context);
          if (result189 !== null) {
            var result188 = result189;
          } else {
            var result188 = null;;
          };
        };
      }
      context.reportMatchFailures = savedReportMatchFailuresVar2;
      if (result188 === null) {
        var result186 = '';
      } else {
        var result186 = null;
        this._pos = savedPos33;
      }
      if (result186 !== null) {
        if (this._input.length > this._pos) {
          var result187 = this._input.charAt(this._pos);
          this._pos++;
        } else {
          var result187 = null;
          if (context.reportMatchFailures) {
            this._matchFailed('any character');
          }
        }
        if (result187 !== null) {
          var result185 = [result186, result187];
        } else {
          var result185 = null;
          this._pos = savedPos32;
        }
      } else {
        var result185 = null;
        this._pos = savedPos32;
      }
      var result184 = result185 !== null
        ? (function($1, $2) {  return $2;  }).apply(null, result185)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result184
      };
      return result184;
    },
    
    _parse_class: function(context) {
      var cacheKey = "class" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      var savedPos34 = this._pos;
      if (this._input.substr(this._pos, 1) === "[") {
        var result194 = "[";
        this._pos += 1;
      } else {
        var result194 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("["));
        }
      }
      if (result194 !== null) {
        if (this._input.substr(this._pos, 1) === "^") {
          var result202 = "^";
          this._pos += 1;
        } else {
          var result202 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("^"));
          }
        }
        var result195 = result202 !== null ? result202 : '';
        if (result195 !== null) {
          var result196 = [];
          var result201 = this._parse_classCharacterRange(context);
          if (result201 !== null) {
            var result199 = result201;
          } else {
            var result200 = this._parse_classCharacter(context);
            if (result200 !== null) {
              var result199 = result200;
            } else {
              var result199 = null;;
            };
          }
          while (result199 !== null) {
            result196.push(result199);
            var result201 = this._parse_classCharacterRange(context);
            if (result201 !== null) {
              var result199 = result201;
            } else {
              var result200 = this._parse_classCharacter(context);
              if (result200 !== null) {
                var result199 = result200;
              } else {
                var result199 = null;;
              };
            }
          }
          if (result196 !== null) {
            if (this._input.substr(this._pos, 1) === "]") {
              var result197 = "]";
              this._pos += 1;
            } else {
              var result197 = null;
              if (context.reportMatchFailures) {
                this._matchFailed(this._quoteString("]"));
              }
            }
            if (result197 !== null) {
              var result198 = this._parse___(context);
              if (result198 !== null) {
                var result193 = [result194, result195, result196, result197, result198];
              } else {
                var result193 = null;
                this._pos = savedPos34;
              }
            } else {
              var result193 = null;
              this._pos = savedPos34;
            }
          } else {
            var result193 = null;
            this._pos = savedPos34;
          }
        } else {
          var result193 = null;
          this._pos = savedPos34;
        }
      } else {
        var result193 = null;
        this._pos = savedPos34;
      }
      var result192 = result193 !== null
        ? (function($1, $2, $3, $4, $5) { 
          parts = PEG.ArrayUtils.map($3, function(part) { return part.data; });
          rawText = "["
            + $2
            + PEG.ArrayUtils.map($3, function(part) { return part.rawText; }).join("")
            + "]";
        
          return {
            type:     "class",
            inverted: $2 === "^",
            parts:    parts,
            // FIXME: Get the raw text from the input directly.
            rawText:  rawText
          };
         }).apply(null, result193)
        : null;
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result192 === null) {
        this._matchFailed("character class");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result192
      };
      return result192;
    },
    
    _parse_classCharacterRange: function(context) {
      var cacheKey = "classCharacterRange" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos35 = this._pos;
      var result205 = this._parse_classCharacter(context);
      if (result205 !== null) {
        if (this._input.substr(this._pos, 1) === "-") {
          var result206 = "-";
          this._pos += 1;
        } else {
          var result206 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("-"));
          }
        }
        if (result206 !== null) {
          var result207 = this._parse_classCharacter(context);
          if (result207 !== null) {
            var result204 = [result205, result206, result207];
          } else {
            var result204 = null;
            this._pos = savedPos35;
          }
        } else {
          var result204 = null;
          this._pos = savedPos35;
        }
      } else {
        var result204 = null;
        this._pos = savedPos35;
      }
      var result203 = result204 !== null
        ? (function($1, $2, $3) { 
          if ($1.data.charCodeAt(0) > $3.data.charCodeAt(0)) {
            throw new this.SyntaxError(
              "Invalid character range: " + $1.rawText + "-" + $2.rawText + "."
            );
          }
        
          return {
            data:    [$1.data, $3.data],
            // FIXME: Get the raw text from the input directly.
            rawText: $1.rawText + "-" + $3.rawText
          }
         }).apply(null, result204)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result203
      };
      return result203;
    },
    
    _parse_classCharacter: function(context) {
      var cacheKey = "classCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result209 = this._parse_bracketDelimitedCharacter(context);
      var result208 = result209 !== null
        ? (function($1) { 
          return {
            data:    $1,
            // FIXME: Get the raw text from the input directly.
            rawText: PEG.RegExpUtils.quoteForClass($1)
          };
         })(result209)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result208
      };
      return result208;
    },
    
    _parse_bracketDelimitedCharacter: function(context) {
      var cacheKey = "bracketDelimitedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result216 = this._parse_simpleBracketDelimitedCharacter(context);
      if (result216 !== null) {
        var result210 = result216;
      } else {
        var result215 = this._parse_simpleEscapeSequence(context);
        if (result215 !== null) {
          var result210 = result215;
        } else {
          var result214 = this._parse_zeroEscapeSequence(context);
          if (result214 !== null) {
            var result210 = result214;
          } else {
            var result213 = this._parse_hexEscapeSequence(context);
            if (result213 !== null) {
              var result210 = result213;
            } else {
              var result212 = this._parse_unicodeEscapeSequence(context);
              if (result212 !== null) {
                var result210 = result212;
              } else {
                var result211 = this._parse_eolEscapeSequence(context);
                if (result211 !== null) {
                  var result210 = result211;
                } else {
                  var result210 = null;;
                };
              };
            };
          };
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result210
      };
      return result210;
    },
    
    _parse_simpleBracketDelimitedCharacter: function(context) {
      var cacheKey = "simpleBracketDelimitedCharacter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos36 = this._pos;
      var savedPos37 = this._pos;
      var savedReportMatchFailuresVar3 = context.reportMatchFailures;
      context.reportMatchFailures = false;
      if (this._input.substr(this._pos, 1) === "]") {
        var result224 = "]";
        this._pos += 1;
      } else {
        var result224 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("]"));
        }
      }
      if (result224 !== null) {
        var result221 = result224;
      } else {
        if (this._input.substr(this._pos, 1) === "\\") {
          var result223 = "\\";
          this._pos += 1;
        } else {
          var result223 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("\\"));
          }
        }
        if (result223 !== null) {
          var result221 = result223;
        } else {
          var result222 = this._parse_eolChar(context);
          if (result222 !== null) {
            var result221 = result222;
          } else {
            var result221 = null;;
          };
        };
      }
      context.reportMatchFailures = savedReportMatchFailuresVar3;
      if (result221 === null) {
        var result219 = '';
      } else {
        var result219 = null;
        this._pos = savedPos37;
      }
      if (result219 !== null) {
        if (this._input.length > this._pos) {
          var result220 = this._input.charAt(this._pos);
          this._pos++;
        } else {
          var result220 = null;
          if (context.reportMatchFailures) {
            this._matchFailed('any character');
          }
        }
        if (result220 !== null) {
          var result218 = [result219, result220];
        } else {
          var result218 = null;
          this._pos = savedPos36;
        }
      } else {
        var result218 = null;
        this._pos = savedPos36;
      }
      var result217 = result218 !== null
        ? (function($1, $2) {  return $2;  }).apply(null, result218)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result217
      };
      return result217;
    },
    
    _parse_simpleEscapeSequence: function(context) {
      var cacheKey = "simpleEscapeSequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos38 = this._pos;
      if (this._input.substr(this._pos, 1) === "\\") {
        var result227 = "\\";
        this._pos += 1;
      } else {
        var result227 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\\"));
        }
      }
      if (result227 !== null) {
        var savedPos39 = this._pos;
        var savedReportMatchFailuresVar4 = context.reportMatchFailures;
        context.reportMatchFailures = false;
        var result234 = this._parse_digit(context);
        if (result234 !== null) {
          var result230 = result234;
        } else {
          if (this._input.substr(this._pos, 1) === "x") {
            var result233 = "x";
            this._pos += 1;
          } else {
            var result233 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("x"));
            }
          }
          if (result233 !== null) {
            var result230 = result233;
          } else {
            if (this._input.substr(this._pos, 1) === "u") {
              var result232 = "u";
              this._pos += 1;
            } else {
              var result232 = null;
              if (context.reportMatchFailures) {
                this._matchFailed(this._quoteString("u"));
              }
            }
            if (result232 !== null) {
              var result230 = result232;
            } else {
              var result231 = this._parse_eolChar(context);
              if (result231 !== null) {
                var result230 = result231;
              } else {
                var result230 = null;;
              };
            };
          };
        }
        context.reportMatchFailures = savedReportMatchFailuresVar4;
        if (result230 === null) {
          var result228 = '';
        } else {
          var result228 = null;
          this._pos = savedPos39;
        }
        if (result228 !== null) {
          if (this._input.length > this._pos) {
            var result229 = this._input.charAt(this._pos);
            this._pos++;
          } else {
            var result229 = null;
            if (context.reportMatchFailures) {
              this._matchFailed('any character');
            }
          }
          if (result229 !== null) {
            var result226 = [result227, result228, result229];
          } else {
            var result226 = null;
            this._pos = savedPos38;
          }
        } else {
          var result226 = null;
          this._pos = savedPos38;
        }
      } else {
        var result226 = null;
        this._pos = savedPos38;
      }
      var result225 = result226 !== null
        ? (function($1, $2, $3) { 
          return $3
            .replace("b", "\b")
            .replace("f", "\f")
            .replace("n", "\n")
            .replace("r", "\r")
            .replace("t", "\t")
            .replace("v", "\x0B") // IE does not recognize "\v".
         }).apply(null, result226)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result225
      };
      return result225;
    },
    
    _parse_zeroEscapeSequence: function(context) {
      var cacheKey = "zeroEscapeSequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos40 = this._pos;
      if (this._input.substr(this._pos, 2) === "\\0") {
        var result237 = "\\0";
        this._pos += 2;
      } else {
        var result237 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\\0"));
        }
      }
      if (result237 !== null) {
        var savedPos41 = this._pos;
        var savedReportMatchFailuresVar5 = context.reportMatchFailures;
        context.reportMatchFailures = false;
        var result239 = this._parse_digit(context);
        context.reportMatchFailures = savedReportMatchFailuresVar5;
        if (result239 === null) {
          var result238 = '';
        } else {
          var result238 = null;
          this._pos = savedPos41;
        }
        if (result238 !== null) {
          var result236 = [result237, result238];
        } else {
          var result236 = null;
          this._pos = savedPos40;
        }
      } else {
        var result236 = null;
        this._pos = savedPos40;
      }
      var result235 = result236 !== null
        ? (function($1, $2) {  return "\0";  }).apply(null, result236)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result235
      };
      return result235;
    },
    
    _parse_hexEscapeSequence: function(context) {
      var cacheKey = "hexEscapeSequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos42 = this._pos;
      if (this._input.substr(this._pos, 2) === "\\x") {
        var result242 = "\\x";
        this._pos += 2;
      } else {
        var result242 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\\x"));
        }
      }
      if (result242 !== null) {
        var result243 = this._parse_hexDigit(context);
        if (result243 !== null) {
          var result244 = this._parse_hexDigit(context);
          if (result244 !== null) {
            var result241 = [result242, result243, result244];
          } else {
            var result241 = null;
            this._pos = savedPos42;
          }
        } else {
          var result241 = null;
          this._pos = savedPos42;
        }
      } else {
        var result241 = null;
        this._pos = savedPos42;
      }
      var result240 = result241 !== null
        ? (function($1, $2, $3) { 
          return String.fromCharCode(parseInt("0x" + $2 + $3));
         }).apply(null, result241)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result240
      };
      return result240;
    },
    
    _parse_unicodeEscapeSequence: function(context) {
      var cacheKey = "unicodeEscapeSequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos43 = this._pos;
      if (this._input.substr(this._pos, 2) === "\\u") {
        var result247 = "\\u";
        this._pos += 2;
      } else {
        var result247 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\\u"));
        }
      }
      if (result247 !== null) {
        var result248 = this._parse_hexDigit(context);
        if (result248 !== null) {
          var result249 = this._parse_hexDigit(context);
          if (result249 !== null) {
            var result250 = this._parse_hexDigit(context);
            if (result250 !== null) {
              var result251 = this._parse_hexDigit(context);
              if (result251 !== null) {
                var result246 = [result247, result248, result249, result250, result251];
              } else {
                var result246 = null;
                this._pos = savedPos43;
              }
            } else {
              var result246 = null;
              this._pos = savedPos43;
            }
          } else {
            var result246 = null;
            this._pos = savedPos43;
          }
        } else {
          var result246 = null;
          this._pos = savedPos43;
        }
      } else {
        var result246 = null;
        this._pos = savedPos43;
      }
      var result245 = result246 !== null
        ? (function($1, $2, $3, $4, $5) { 
          return String.fromCharCode(parseInt("0x" + $2 + $3 + $4 + $5));
         }).apply(null, result246)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result245
      };
      return result245;
    },
    
    _parse_eolEscapeSequence: function(context) {
      var cacheKey = "eolEscapeSequence" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos44 = this._pos;
      if (this._input.substr(this._pos, 1) === "\\") {
        var result254 = "\\";
        this._pos += 1;
      } else {
        var result254 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\\"));
        }
      }
      if (result254 !== null) {
        var result255 = this._parse_eol(context);
        if (result255 !== null) {
          var result253 = [result254, result255];
        } else {
          var result253 = null;
          this._pos = savedPos44;
        }
      } else {
        var result253 = null;
        this._pos = savedPos44;
      }
      var result252 = result253 !== null
        ? (function($1, $2) {  return $2;  }).apply(null, result253)
        : null;
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result252
      };
      return result252;
    },
    
    _parse_digit: function(context) {
      var cacheKey = "digit" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[0-9]/) !== null) {
        var result256 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result256 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[0-9]");
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result256
      };
      return result256;
    },
    
    _parse_hexDigit: function(context) {
      var cacheKey = "hexDigit" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[0-9a-fA-F]/) !== null) {
        var result257 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result257 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[0-9a-fA-F]");
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result257
      };
      return result257;
    },
    
    _parse_letter: function(context) {
      var cacheKey = "letter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result260 = this._parse_lowerCaseLetter(context);
      if (result260 !== null) {
        var result258 = result260;
      } else {
        var result259 = this._parse_upperCaseLetter(context);
        if (result259 !== null) {
          var result258 = result259;
        } else {
          var result258 = null;;
        };
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result258
      };
      return result258;
    },
    
    _parse_lowerCaseLetter: function(context) {
      var cacheKey = "lowerCaseLetter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[a-z]/) !== null) {
        var result261 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result261 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[a-z]");
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result261
      };
      return result261;
    },
    
    _parse_upperCaseLetter: function(context) {
      var cacheKey = "upperCaseLetter" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[A-Z]/) !== null) {
        var result262 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result262 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[A-Z]");
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result262
      };
      return result262;
    },
    
    _parse___: function(context) {
      var cacheKey = "__" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var result263 = [];
      var result267 = this._parse_whitespace(context);
      if (result267 !== null) {
        var result264 = result267;
      } else {
        var result266 = this._parse_eol(context);
        if (result266 !== null) {
          var result264 = result266;
        } else {
          var result265 = this._parse_comment(context);
          if (result265 !== null) {
            var result264 = result265;
          } else {
            var result264 = null;;
          };
        };
      }
      while (result264 !== null) {
        result263.push(result264);
        var result267 = this._parse_whitespace(context);
        if (result267 !== null) {
          var result264 = result267;
        } else {
          var result266 = this._parse_eol(context);
          if (result266 !== null) {
            var result264 = result266;
          } else {
            var result265 = this._parse_comment(context);
            if (result265 !== null) {
              var result264 = result265;
            } else {
              var result264 = null;;
            };
          };
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result263
      };
      return result263;
    },
    
    _parse_comment: function(context) {
      var cacheKey = "comment" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      var result270 = this._parse_singleLineComment(context);
      if (result270 !== null) {
        var result268 = result270;
      } else {
        var result269 = this._parse_multiLineComment(context);
        if (result269 !== null) {
          var result268 = result269;
        } else {
          var result268 = null;;
        };
      }
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result268 === null) {
        this._matchFailed("comment");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result268
      };
      return result268;
    },
    
    _parse_singleLineComment: function(context) {
      var cacheKey = "singleLineComment" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos45 = this._pos;
      if (this._input.substr(this._pos, 2) === "//") {
        var result272 = "//";
        this._pos += 2;
      } else {
        var result272 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("//"));
        }
      }
      if (result272 !== null) {
        var result273 = [];
        var savedPos46 = this._pos;
        var savedPos47 = this._pos;
        var savedReportMatchFailuresVar6 = context.reportMatchFailures;
        context.reportMatchFailures = false;
        var result277 = this._parse_eolChar(context);
        context.reportMatchFailures = savedReportMatchFailuresVar6;
        if (result277 === null) {
          var result275 = '';
        } else {
          var result275 = null;
          this._pos = savedPos47;
        }
        if (result275 !== null) {
          if (this._input.length > this._pos) {
            var result276 = this._input.charAt(this._pos);
            this._pos++;
          } else {
            var result276 = null;
            if (context.reportMatchFailures) {
              this._matchFailed('any character');
            }
          }
          if (result276 !== null) {
            var result274 = [result275, result276];
          } else {
            var result274 = null;
            this._pos = savedPos46;
          }
        } else {
          var result274 = null;
          this._pos = savedPos46;
        }
        while (result274 !== null) {
          result273.push(result274);
          var savedPos46 = this._pos;
          var savedPos47 = this._pos;
          var savedReportMatchFailuresVar6 = context.reportMatchFailures;
          context.reportMatchFailures = false;
          var result277 = this._parse_eolChar(context);
          context.reportMatchFailures = savedReportMatchFailuresVar6;
          if (result277 === null) {
            var result275 = '';
          } else {
            var result275 = null;
            this._pos = savedPos47;
          }
          if (result275 !== null) {
            if (this._input.length > this._pos) {
              var result276 = this._input.charAt(this._pos);
              this._pos++;
            } else {
              var result276 = null;
              if (context.reportMatchFailures) {
                this._matchFailed('any character');
              }
            }
            if (result276 !== null) {
              var result274 = [result275, result276];
            } else {
              var result274 = null;
              this._pos = savedPos46;
            }
          } else {
            var result274 = null;
            this._pos = savedPos46;
          }
        }
        if (result273 !== null) {
          var result271 = [result272, result273];
        } else {
          var result271 = null;
          this._pos = savedPos45;
        }
      } else {
        var result271 = null;
        this._pos = savedPos45;
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result271
      };
      return result271;
    },
    
    _parse_multiLineComment: function(context) {
      var cacheKey = "multiLineComment" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      var savedPos48 = this._pos;
      if (this._input.substr(this._pos, 2) === "/*") {
        var result279 = "/*";
        this._pos += 2;
      } else {
        var result279 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("/*"));
        }
      }
      if (result279 !== null) {
        var result280 = [];
        var savedPos49 = this._pos;
        var savedPos50 = this._pos;
        var savedReportMatchFailuresVar7 = context.reportMatchFailures;
        context.reportMatchFailures = false;
        if (this._input.substr(this._pos, 2) === "*/") {
          var result285 = "*/";
          this._pos += 2;
        } else {
          var result285 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("*/"));
          }
        }
        context.reportMatchFailures = savedReportMatchFailuresVar7;
        if (result285 === null) {
          var result283 = '';
        } else {
          var result283 = null;
          this._pos = savedPos50;
        }
        if (result283 !== null) {
          if (this._input.length > this._pos) {
            var result284 = this._input.charAt(this._pos);
            this._pos++;
          } else {
            var result284 = null;
            if (context.reportMatchFailures) {
              this._matchFailed('any character');
            }
          }
          if (result284 !== null) {
            var result282 = [result283, result284];
          } else {
            var result282 = null;
            this._pos = savedPos49;
          }
        } else {
          var result282 = null;
          this._pos = savedPos49;
        }
        while (result282 !== null) {
          result280.push(result282);
          var savedPos49 = this._pos;
          var savedPos50 = this._pos;
          var savedReportMatchFailuresVar7 = context.reportMatchFailures;
          context.reportMatchFailures = false;
          if (this._input.substr(this._pos, 2) === "*/") {
            var result285 = "*/";
            this._pos += 2;
          } else {
            var result285 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("*/"));
            }
          }
          context.reportMatchFailures = savedReportMatchFailuresVar7;
          if (result285 === null) {
            var result283 = '';
          } else {
            var result283 = null;
            this._pos = savedPos50;
          }
          if (result283 !== null) {
            if (this._input.length > this._pos) {
              var result284 = this._input.charAt(this._pos);
              this._pos++;
            } else {
              var result284 = null;
              if (context.reportMatchFailures) {
                this._matchFailed('any character');
              }
            }
            if (result284 !== null) {
              var result282 = [result283, result284];
            } else {
              var result282 = null;
              this._pos = savedPos49;
            }
          } else {
            var result282 = null;
            this._pos = savedPos49;
          }
        }
        if (result280 !== null) {
          if (this._input.substr(this._pos, 2) === "*/") {
            var result281 = "*/";
            this._pos += 2;
          } else {
            var result281 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("*/"));
            }
          }
          if (result281 !== null) {
            var result278 = [result279, result280, result281];
          } else {
            var result278 = null;
            this._pos = savedPos48;
          }
        } else {
          var result278 = null;
          this._pos = savedPos48;
        }
      } else {
        var result278 = null;
        this._pos = savedPos48;
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result278
      };
      return result278;
    },
    
    _parse_eol: function(context) {
      var cacheKey = "eol" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      if (this._input.substr(this._pos, 1) === "\n") {
        var result291 = "\n";
        this._pos += 1;
      } else {
        var result291 = null;
        if (context.reportMatchFailures) {
          this._matchFailed(this._quoteString("\n"));
        }
      }
      if (result291 !== null) {
        var result286 = result291;
      } else {
        if (this._input.substr(this._pos, 2) === "\r\n") {
          var result290 = "\r\n";
          this._pos += 2;
        } else {
          var result290 = null;
          if (context.reportMatchFailures) {
            this._matchFailed(this._quoteString("\r\n"));
          }
        }
        if (result290 !== null) {
          var result286 = result290;
        } else {
          if (this._input.substr(this._pos, 1) === "\r") {
            var result289 = "\r";
            this._pos += 1;
          } else {
            var result289 = null;
            if (context.reportMatchFailures) {
              this._matchFailed(this._quoteString("\r"));
            }
          }
          if (result289 !== null) {
            var result286 = result289;
          } else {
            if (this._input.substr(this._pos, 1) === "\u2028") {
              var result288 = "\u2028";
              this._pos += 1;
            } else {
              var result288 = null;
              if (context.reportMatchFailures) {
                this._matchFailed(this._quoteString("\u2028"));
              }
            }
            if (result288 !== null) {
              var result286 = result288;
            } else {
              if (this._input.substr(this._pos, 1) === "\u2029") {
                var result287 = "\u2029";
                this._pos += 1;
              } else {
                var result287 = null;
                if (context.reportMatchFailures) {
                  this._matchFailed(this._quoteString("\u2029"));
                }
              }
              if (result287 !== null) {
                var result286 = result287;
              } else {
                var result286 = null;;
              };
            };
          };
        };
      }
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result286 === null) {
        this._matchFailed("end of line");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result286
      };
      return result286;
    },
    
    _parse_eolChar: function(context) {
      var cacheKey = "eolChar" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      
      if (this._input.substr(this._pos).match(/^[\n\r\u2028\u2029]/) !== null) {
        var result292 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result292 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[\\n\\r\\u2028\\u2029]");
        }
      }
      
      
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result292
      };
      return result292;
    },
    
    _parse_whitespace: function(context) {
      var cacheKey = "whitespace" + '@' + this._pos;
      var cachedResult = this._cache[cacheKey];
      if (cachedResult) {
        this._pos = cachedResult.nextPos;
        return cachedResult.result;
      }
      
      var pos = this._pos;
      
      var savedReportMatchFailures = context.reportMatchFailures;
      context.reportMatchFailures = false;
      if (this._input.substr(this._pos).match(/^[ 	 ﻿ ᠎ -   　]/) !== null) {
        var result293 = this._input.charAt(this._pos);
        this._pos++;
      } else {
        var result293 = null;
        if (context.reportMatchFailures) {
          this._matchFailed("[ 	 ﻿ ᠎ -   　]");
        }
      }
      context.reportMatchFailures = savedReportMatchFailures;
      if (context.reportMatchFailures && result293 === null) {
        this._matchFailed("whitespace");
      }
      
      this._cache[cacheKey] = {
        nextPos: this._pos,
        result:  result293
      };
      return result293;
    },
    
    /*
     * Parses the input with a generated parser. If the parsing is successfull,
     * returns a value explicitly or implicitly specified by the grammar from
     * which the parser was generated (see |PEG.buildParser|). If the parsing is
     * unsuccessful, throws |PEG.grammarParser.SyntaxError| describing the error.
     */
    parse: function(input) {
      var that = this;
      
      function initialize() {
        that._input = input;
        that._pos = 0;
        that._rightmostMatchFailuresPos = 0;
        that._rightmostMatchFailuresExpected = [];
        that._cache = {};
      }
      
      function buildErrorMessage() {
        function buildExpected(failuresExpected) {
          switch (failuresExpected.length) {
            case 0:
              return 'end of input';
            case 1:
              return failuresExpected[0];
            default:
              failuresExpected.sort();
              return failuresExpected.slice(0, failuresExpected.length - 1).join(', ')
                + ' or '
                + failuresExpected[failuresExpected.length - 1];
          }
        }
        
        var expected = buildExpected(that._rightmostMatchFailuresExpected);
        var pos = Math.max(that._pos, that._rightmostMatchFailuresPos);
        var actual = pos < that._input.length
          ? that._quoteString(that._input.charAt(pos))
          : 'end of input';
        
        return 'Expected ' + expected + ' but ' + actual + ' found.';
      }
      
      function computeErrorPosition() {
        /*
         * The first idea was to use |String.split| to break the input up to the
         * error position along newlines and derive the line and column from
         * there. However IE's |split| implementation is so broken that it was
         * enough to prevent it.
         */
        
        var input = that._input;
        var pos = that._rightmostMatchFailuresPos;
        var line = 1;
        var column = 1;
        var seenCR = false;
        
        for (var i = 0; i < pos; i++) {
          var ch = input.charAt(i);
          if (ch === '\n') {
            if (!seenCR) { line++; }
            column = 1;
            seenCR = false;
          } else if (ch === '\r' | ch === '\u2028' || ch === '\u2029') {
            line++;
            column = 1;
            seenCR = true;
          } else {
            column++;
            seenCR = false;
          }
        }
        
        return { line: line, column: column };
      }
      
      initialize();
      
      var initialContext = {
        reportMatchFailures: true
      };
      
      var result = this['_parse_' + this._startRule](initialContext);
      
      /*
       * The parser is now in one of the following three states:
       *
       * 1. The parser successfully parsed the whole input.
       *
       *    - |result !== null|
       *    - |that._pos === input.length|
       *    - |that._rightmostMatchFailuresExpected.length| may or may not contain
       *      something
       *
       * 2. The parser successfully parsed only a part of the input.
       *
       *    - |result !== null|
       *    - |that._pos < input.length|
       *    - |that._rightmostMatchFailuresExpected.length| may or may not contain
       *      something
       *
       * 3. The parser did not successfully parse any part of the input.
       *
       *   - |result === null|
       *   - |that._pos === 0|
       *   - |that._rightmostMatchFailuresExpected.length| contains at least one failure
       *
       * All code following this comment (including called functions) must
       * handle these states.
       */
      if (result === null || this._pos !== input.length) {
        var errorPosition = computeErrorPosition();
        throw new this.SyntaxError(
          buildErrorMessage(),
          errorPosition.line,
          errorPosition.column
        );
      }
      
      return result;
    },
    
    /* Returns the parser source code. */
    toSource: function() { return this._source; }
  };
  
  /* Thrown when a parser encounters a syntax error. */
  
  result.SyntaxError = function(message, line, column) {
    this.name = 'SyntaxError';
    this.message = message;
    this.line = line;
    this.column = column;
  };
  
  result.SyntaxError.prototype = Error.prototype;
  
  return result;
})();
